unit SDRelektor;

interface

uses D2XXUnit,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Buttons, ExtCtrls, shellapi,Menus,inifiles, CommCtrl,
  dream ;

type
  TForm1 = class(TForm)
    ScrollBar1: TScrollBar;
    Freq: TLabel;
    CMD1_4: TButton;
    CMD2_8: TButton;
    Cmd4_16: TButton;
    Cmd10_40: TButton;
    Cmd25_100: TButton;
    ScrollBar2: TScrollBar;
    Offset: TLabel;
    Mux0: TButton;
    Mux1: TButton;
    Mux2: TButton;
    db10: TButton;
    db20: TButton;
    db0: TButton;
    Mux3: TButton;
    ScrollBar3: TScrollBar;
    Label7: TLabel;
    Xtal: TLabel;
    Mux4: TButton;
    Mux5: TButton;
    Mux6: TButton;
    Mux7: TButton;
    Edit6: TEdit;
    Edit7: TEdit;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Bevel1: TBevel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Beenden1: TMenuItem;
    Optionen1: TMenuItem;
    L_settings: TMenuItem;
    N1: TMenuItem;
    UploadEEProm1: TMenuItem;
    OpenDialog1: TOpenDialog;
    StatusBar1: TStatusBar;
    ProgressBar1: TProgressBar;
    Timer1: TTimer;
    UploadRAM1: TMenuItem;
    L_sp1: TLabel;
    L_sp2: TLabel;
    L_sp3: TLabel;
    L_sp4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure CMD1_4Click(Sender: TObject);
    procedure CMD2_8Click(Sender: TObject);
    procedure Cmd4_16Click(Sender: TObject);
    procedure Cmd10_40Click(Sender: TObject);
    procedure FtoEEPROMClick(Sender: TObject);
    procedure Cmd25_100Click(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure Mux0Click(Sender: TObject);
    procedure Mux1Click(Sender: TObject);
    procedure Mux2Click(Sender: TObject);
    procedure db20Click(Sender: TObject);
    procedure db10Click(Sender: TObject);
    procedure db0Click(Sender: TObject);
    procedure Mux3Click(Sender: TObject);
    procedure ScrollBar3Change(Sender: TObject);
    procedure Mux4Click(Sender: TObject);
    procedure Mux5Click(Sender: TObject);
    procedure Mux6Click(Sender: TObject);
    procedure Mux7Click(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure Edit7Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure L_settingsClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure UploadEEProm1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure UploadRAM1Click(Sender: TObject);
    procedure L_sp1Click(Sender: TObject);
    procedure L_sp2Click(Sender: TObject);
    procedure L_sp3Click(Sender: TObject);
    procedure L_sp4Click(Sender: TObject);
    procedure L_sp1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure L_sp2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure L_sp3MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure L_sp4MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  end;

var
  Form1: TForm1;
  COM: Integer = 2;
  Codearray : array [0..5000] of byte;
  Fehler: Boolean;
  P,Q,Div1N: Integer;
  R40, R41, R42 : Integer;
  P0: Integer;
  IICadr,n: Integer;
  Step: Real;
  VFOhigh: Boolean;
  FT_port: Integer = 0;
  Buf_adr: Integer = 0;
  Mux: Integer;
  dB: Integer;

implementation



{$R *.DFM}
procedure SCL(d:Integer);
begin
  if d=0 then FT_port := FT_port and (255-2) else FT_port := FT_port or (2); //Bit 2
  FT_Out_Buffer[Buf_adr] := FT_port;
  Buf_adr := Buf_adr +1;
end;

procedure SDA(d:Integer);
begin
  if d=0 then FT_port := FT_port and (255-1) else FT_port := FT_port or (1); //Bit 2
  //FT_port := FT_port and (255-16); //Bit 4
  //FT_port := FT_port + d * 16;
  FT_Out_Buffer[Buf_adr] := FT_port;
  Buf_adr := Buf_adr +1;
end;


procedure I2C_Init;
begin
  SCL(1); SDA(1);          { SCL=1, SDA=1 }
end;

procedure Start;
begin
  SDA(0);          { SDA=0 }
  SCL(0);          { SCL=0 }
end;

procedure Stop;
begin
  SCL(0); SDA(0);  { SCL=0, SDA=0 }
  SCL(1);          { SCL=1 }
  SDA(1);          { SDA=1 }
end;

procedure Acknowledge;
begin
  SCL(0); SDA(0);  { SCL=0, SDA=0 }
  SCL(1);          { SCL=1 }
  SCL(0);          { SCL=0 }
end;

procedure KeinAcknowledge;
begin
  SCL(0); SDA(1);  { SCL=0, SDA=1 }
  SCL(1);          { SCL=1 }
  SCL(0);          { SCL=0 }
end;

Function Ausgeben (Wert : Byte): Boolean;
var Bitwert, n: Byte;
begin
  Ausgeben := true;
  Bitwert := 128;
  for n:= 1 to 8 do begin
    if (Wert and Bitwert) = Bitwert then SDA(1)
     else SDA(0);   { SDA setzen }
    SCL(1);         { SCL=1 }
    SCL(0);         { SCL=0 }
    Bitwert := Bitwert div 2;
  end;
  SDA(1);           { SDA=1 }
  SCL(1);           { SCL=1, SDA lesen }
  SCL(0);           { SCL=0 }
end;

procedure FreqRechnen(Freq: Integer);
var Qout,Pout : Integer;
    Min, VCO: Real;
begin
  Pout:= 0;
  Qout:= 0;
    if (Freq > 19) and (Freq < 60) then begin
      Div1N := round (2500 / Freq) + 128;
      p := 1000;
      q := 40;
  end;

  if (Freq > 59) and (Freq < 801) then begin
      Div1N := 125;
      p := Freq * 2;
      q := 40;
  end;
  if (Freq > 800) and (Freq < 2001) then begin
      Div1N := 50;
      p := Freq ;
      Q := 50;
  end;
  if (Freq > 2000) and (Freq < 4001) then begin
     Div1N := 25;
     Min := 10000;
     for Q := 100 downto 10 do begin
       for p := 500 to 2000 do begin
          VCO := 10000/Q*P;
          if (abs(4*Freq-VCO/Div1N)) < Min then begin
            Min := abs(4*Freq-VCO/Div1N);
            Qout := Q;
            Pout := P;
          end;
       end;
     end;
     Q := Qout;
     P := POut;
  end;
  if (Freq > 4000) and (Freq < 10001) then begin
     Div1N := 10;
     Min := 10000;
     for Q := 10 to 100 do begin
       for p := 500 to 2000 do begin
          VCO := 10000/Q*P;
          if abs(4*Freq-VCO/Div1N) < Min then begin
            Min := abs(4*Freq-VCO/Div1N);
            Qout := Q;
            Pout := P;
          end;
       end;
     end;
     Q := Qout;
     P := POut;
   end;
  if (Freq > 10000) and (Freq < 20001) then begin
     Div1N := 5;
     Min := 10000;
     for Q := 100 downto 10 do begin
       for p := 500 to 2000 do begin
          VCO := 10000/Q*P;
          if abs(4*Freq-VCO/Div1N) < Min then begin
            Min := abs(4*Freq-VCO/Div1N);
            Qout := Q;
            Pout := P;
          end;
       end;
     end;
     Q := Qout;
     P := POut;
   end;
   if (Freq > 20000) and (Freq < 30001) then begin
     Div1N := 4;
     Min := 10000;
     for Q := 100 downto 10 do begin
       for p := 500 to 2000 do begin
          VCO := 10000/Q*P;
          if abs(4*Freq-VCO/Div1N) < Min then begin
            Min := abs(4*Freq-VCO/Div1N);
            Qout := Q;
            Pout := P;
          end;
       end;
     end;
     Q := Qout;
     P := POut;
   end;


end;



procedure RAM();
var Pump: Integer;
begin
  Buf_adr :=0;
  IICadr:=210;
  Pump := 1;
  If P>479 then Pump := 2;
  If P>639 then Pump := 3;
  If P>799 then Pump := 4;
  P0:= P mod 2;
  R40 := (P div 2 -4 ) div 256 + 4 * Pump + 192;
  R41 := (P div 2 -4) and 255;
  R42 := q-2+128*P0;      //q+2=50, 10 MHz / 50 = 200 kHz
  if VFOhigh then R42 := 23+128*P0;      //q+2=25, 10 MHz / 25 = 400 kHz
  //Label2.caption :=IntToStr (P) + ' ' +IntToStr (R40) + ' '+   IntToStr (R41) + ' '+ IntToStr (R42) + ' ';
  I2C_Init;
  Start;
  Ausgeben (IICadr); {Adr 210, RAM}
  Ausgeben (64);       //Adr 40 hex
  Ausgeben (R40);
  Ausgeben (R41);
  Ausgeben (R42);
  Stop;
  Sleep (10);
  Start;
  Ausgeben (IICadr); {Adr 210, RAM}
  Ausgeben (12);       //Adr 0C hex
  Ausgeben (Div1N);    //DIV1N=50
  Stop;
  Start;
  Ausgeben (IICadr); {Adr 210, RAM}
  Ausgeben (19);       //Adr 13 hex
  //Ausgeben (155);    //DIV1N=50
  Ausgeben (Form1.Scrollbar3.position);    //DIV1N=50
  Stop;

  Open_USB_Device;
  Set_USB_Device_BitMode(255,1);
  FT_Current_Baud:=38400;
  Set_USB_Device_BaudRate;
  Write_USB_Device_Buffer( Buf_adr);
  Close_USB_Device;
end;


function HexToInt (Hexzahl: String): Byte;
var h, l: Byte;
begin
  h:= ord (Hexzahl[1])-48;
  if h>9 then h:=h-7;
  l:= ord (Hexzahl[2])-48;
  if l>9 then l:=l-7;
  Result := 16*h+l;
end;

function ByteToHex (Dat: Integer): String;
var   Hi, Lo: Integer;
      LoHex, HiHex: String;
begin
  Lo := Dat and 15;
  Hi := Dat div 16;
  if Hi > 9 then Hi := Hi + 7;
  HiHex := Chr (48+Hi);
  if Lo > 9 then Lo := Lo + 7;
  LoHex := Chr (48+Lo);
  Result := HiHex + LoHex;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  // Datum Uhrzeit einstellen
  statusbar1.Panels.Items[1].Text:= timetostr(now);
  statusbar1.Panels.Items[2].Text:= datetostr(now);

  //Freq.caption :=  FloatToStr (Scrollbar1.position*Step / 4)+ ' kHz';
   Offset.caption := IntToStr (Scrollbar2.position);
  Scrollbar1.position := 147;
  Freq.caption :=  FloatToStr (147) + ' kHz';
  Mux := 0;
  FT_port :=  FT_port and $63;        //0,1 = I2C, 2,3,4=MUX, 5,6=Attenuator
  FT_port :=  FT_port + 4 * Mux;
  FreqRechnen (147);
  RAM;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
var
  Ausgang: Real;
  F: Integer;
begin
  Ausgang:= 0;
  F :=Scrollbar1.position;
  FreqRechnen (F);
  if (F > 59) then Ausgang := 10000/Q*P/Div1N/4;
  if (F < 60) then Ausgang := 2500 /(Div1N and 127);
  Ausgang := round (Ausgang);
  Freq.caption :=  FloatToStr (Ausgang+ Scrollbar2.position) + ' kHz';
  RAM;
end;

procedure TForm1.CMD1_4Click(Sender: TObject);
var Freq,N: Integer;
begin
  val('490',Freq,N);
  if Scrollbar1.min > Freq then Scrollbar1.min := Freq-1;
  if Scrollbar1.max < Freq then Scrollbar1.max := Freq+1;
  Scrollbar1.position := Freq-Scrollbar2.position;
end;

procedure TForm1.CMD2_8Click(Sender: TObject);
var Freq,N: Integer;
begin
  val('518',Freq,N);
  if Scrollbar1.min > Freq then Scrollbar1.min := Freq-1;
  if Scrollbar1.max < Freq then Scrollbar1.max := Freq+1;
  Scrollbar1.position := Freq-Scrollbar2.position;
end;

procedure TForm1.Cmd4_16Click(Sender: TObject);
var Freq,N: Integer;
begin
  val('4209',Freq,N);
  if Scrollbar1.min > Freq then Scrollbar1.min := Freq-1;
  if Scrollbar1.max < Freq then Scrollbar1.max := Freq+1;
  Scrollbar1.position := Freq-Scrollbar2.position;
end;

procedure TForm1.Cmd10_40Click(Sender: TObject);
var Freq,N: Integer;
begin
  val('7880',Freq,N);
  if Scrollbar1.min > Freq then Scrollbar1.min := Freq-1;
  if Scrollbar1.max < Freq then Scrollbar1.max := Freq+1;
  Scrollbar1.position := Freq-Scrollbar2.position;
end;

procedure TForm1.Cmd25_100Click(Sender: TObject);
var Freq,N: Integer;
begin
  val('13882',Freq,N);
  if Scrollbar1.min > Freq then Scrollbar1.min := Freq-1;
  if Scrollbar1.max < Freq then Scrollbar1.max := Freq+1;
  Scrollbar1.position := Freq-Scrollbar2.position;
end;

procedure TForm1.FtoEEPROMClick(Sender: TObject);
var Pump: Integer;
begin
  IICadr:=208;
  Pump := 1;
  If P>479 then Pump := 2;
  If P>639 then Pump := 3;
  If P>799 then Pump := 4;
  P0:= P mod 2;
  R40 := (P div 2 -4 ) div 256 + 4 * Pump + 192;
  R41 := (P div 2 -4) and 255;
  R42 := 48+128*P0;      //q+2=50, 10 MHz / 50 = 200 kHz
  if VFOhigh then R42 := 23+128*P0;      //q+2=25, 10 MHz / 25 = 400 kHz
  //Label2.caption :=IntToStr (P) + ' ' +IntToStr (R40) + ' '+   IntToStr (R41) + ' '+ IntToStr (R42) + ' ';
  Buf_adr :=0;
  I2C_Init;
  Start;
  Ausgeben (IICadr); {Adr 210, RAM}
  Ausgeben (64);       //Adr 40 hex
  Ausgeben (R40);
  Ausgeben (R41);
  Ausgeben (R42);
  Stop;
  Open_USB_Device;
  Set_USB_Device_BitMode(255,1);
  FT_Current_Baud:=38400;
  Set_USB_Device_BaudRate;
  Write_USB_Device_Buffer( Buf_adr);
  Close_USB_Device;
  Sleep (10);
  Buf_adr :=0;
  Start;
  Ausgeben (IICadr); {Adr 210, RAM}
  Ausgeben (12);       //Adr 0C hex
  Ausgeben (Div1N);    //DIV1N=50
  Stop;
  Open_USB_Device;
  Set_USB_Device_BitMode(255,1);
  FT_Current_Baud:=38400;
  Set_USB_Device_BaudRate;
  Write_USB_Device_Buffer( Buf_adr);
  Close_USB_Device;
  Sleep (10);
 end;



procedure TForm1.ScrollBar2Change(Sender: TObject);
var Ausgang : Real;
  F: Integer;
begin
  Ausgang:= 0;
  Offset.caption := IntToStr (Scrollbar2.position);
  F :=Scrollbar1.position;
  FreqRechnen (F);
  if (F > 59) then Ausgang := 10000/Q*P/Div1N/4;
  if (F < 60) then Ausgang := 2500 /(Div1N and 127);
  Ausgang := round (Ausgang);
  Freq.caption :=  FloatToStr (Ausgang+ Scrollbar2.position) + ' kHz';
  RAM;
end;


procedure TForm1.Mux0Click(Sender: TObject);
begin
  Mux := 0;
  FT_port :=  FT_port and $63;        //0,1 = I2C, 2,3,4=MUX, 5,6=Attenuator
  FT_port :=  FT_port + 4 * Mux;
  RAM;
end;

procedure TForm1.Mux1Click(Sender: TObject);
begin
  Mux := 1;
  FT_port :=  FT_port and $63;
  FT_port :=  FT_port + 4 * Mux;
  RAM;
end;

procedure TForm1.Mux2Click(Sender: TObject);
begin
  Mux := 2;
  FT_port :=  FT_port and $63;
  FT_port :=  FT_port + 4 * Mux;
  RAM;
end;

procedure TForm1.db20Click(Sender: TObject);
begin
  dB := 2;
  FT_port :=  FT_port and $1F;
  FT_port :=  FT_port + 32 * dB;
  RAM;
end;

procedure TForm1.db10Click(Sender: TObject);
begin
  dB := 1;
  FT_port :=  FT_port and $1F;
  FT_port :=  FT_port + 32 * dB;
  RAM;
end;

procedure TForm1.db0Click(Sender: TObject);
begin
  dB := 0;
  FT_port :=  FT_port and $1F;
  FT_port :=  FT_port + 32 * dB;
  RAM;
end;

procedure TForm1.Mux3Click(Sender: TObject);
begin
  Mux := 3;
  FT_port :=  FT_port and $63;
  FT_port :=  FT_port + 4 * Mux;
  RAM;
end;

procedure TForm1.ScrollBar3Change(Sender: TObject);
begin
 RAM;
end;

procedure TForm1.Mux4Click(Sender: TObject);
begin
  Mux := 4;
  FT_port :=  FT_port and $63;
  FT_port :=  FT_port + 4 * Mux;
  RAM;
end;

procedure TForm1.Mux5Click(Sender: TObject);
begin
  Mux := 5;
  FT_port :=  FT_port and $63;
  FT_port :=  FT_port + 4 * Mux;
  RAM;
end;

procedure TForm1.Mux6Click(Sender: TObject);
begin
  Mux := 6;
  FT_port :=  FT_port and $63;
  FT_port :=  FT_port + 4 * Mux;
  RAM;
end;

procedure TForm1.Mux7Click(Sender: TObject);
begin
  Mux := 7;
  FT_port :=  FT_port and $63;
  FT_port :=  FT_port + 4 * Mux;
  RAM;
end;

procedure TForm1.Edit6Change(Sender: TObject);
var min,n: Integer;
begin
  val (Edit6.text,Min,n);
  if min < 20 then min := 20;
  if Scrollbar1.max < min then Scrollbar1.max := min+1;
  if Scrollbar1.position < min then Scrollbar1.position := min;
  Scrollbar1.min := min;
end;

procedure TForm1.Edit7Change(Sender: TObject);
var max,n: Integer;
begin
  val (Edit7.text,Max,n);
  if max < 20 then max := 20;
  if Scrollbar1.min > max then Scrollbar1.min := max-1;
  if Scrollbar1.position > max then Scrollbar1.position := max;
  Scrollbar1.max := max;
end;

procedure TForm1.Button1Click(Sender: TObject);
var Freq,N: Integer;
begin
  val('3855',Freq,N);
  if Scrollbar1.min > Freq then Scrollbar1.min := Freq-1;
  if Scrollbar1.max < Freq then Scrollbar1.max := Freq+1;
  Scrollbar1.position := Freq-Scrollbar2.position;
end;

procedure TForm1.Button2Click(Sender: TObject);
var Freq,N: Integer;
begin
  val('10101',Freq,N);
  if Scrollbar1.min > Freq then Scrollbar1.min := Freq-1;
  if Scrollbar1.max < Freq then Scrollbar1.max := Freq+1;
  Scrollbar1.position := Freq-Scrollbar2.position;
end;

procedure TForm1.Button3Click(Sender: TObject);
var Freq,N: Integer;
begin
  val('4583',Freq,N);
  if Scrollbar1.min > Freq then Scrollbar1.min := Freq-1;
  if Scrollbar1.max < Freq then Scrollbar1.max := Freq+1;
  Scrollbar1.position := Freq-Scrollbar2.position;
end;

procedure TForm1.Button4Click(Sender: TObject);
var Freq,N: Integer;
begin
  val('7646',Freq,N);
  if Scrollbar1.min > Freq then Scrollbar1.min := Freq-1;
  if Scrollbar1.max < Freq then Scrollbar1.max := Freq+1;
  Scrollbar1.position := Freq-Scrollbar2.position;
end;

procedure TForm1.Button7Click(Sender: TObject);
var Freq,N: Integer;
begin
  val('14467',Freq,N);
  if Scrollbar1.min > Freq then Scrollbar1.min := Freq-1;
  if Scrollbar1.max < Freq then Scrollbar1.max := Freq+1;
  Scrollbar1.position := Freq-Scrollbar2.position;
end;

procedure TForm1.Button6Click(Sender: TObject);
var Freq,N: Integer;
begin
  val('11039',Freq,N);
  if Scrollbar1.min > Freq then Scrollbar1.min := Freq-1;
  if Scrollbar1.max < Freq then Scrollbar1.max := Freq+1;
  Scrollbar1.position := Freq-Scrollbar2.position;
end;

procedure TForm1.Button5Click(Sender: TObject);
var Freq,N: Integer;
begin
  val('147',Freq,N);
  if Scrollbar1.min > Freq then Scrollbar1.min := Freq-1;
  if Scrollbar1.max < Freq then Scrollbar1.max := Freq+1;
  Scrollbar1.position := Freq-Scrollbar2.position;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  shellexecute(handle,nil,PChar('dream.exe'),PChar(''),PChar(form2.Edit1.text),sw_shownormal);
end;

procedure TForm1.Beenden1Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.L_settingsClick(Sender: TObject);
begin
  form2.showmodal;
end;

procedure TForm1.FormShow(Sender: TObject);
var
  IniDat: TiniFile;
  r:      TRect;
begin

// Prozessleiste initialisieren
  StatusBar1.Perform(SB_GETRECT, 0, integer(@R));
  ProgressBar1.Parent := StatusBar1;
  ProgressBar1.BoundsRect := r;
// Prozessleiste initialisieren Ende


// Programmdaten aus INI-Datei laden
  IniDat:= TiniFile.Create('.\setup.ini');
  with IniDat do begin
    Form2.Edit1.Text:= readstring('Dream','Ordner','D:\Dream\');
  end;
  iniDat.free;
// Programmdaten aus INI-Datei laden Ende
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniDat: TiniFile;
begin

// Programmdaten aus INI-Datei laden
  IniDat:= TiniFile.Create('.\setup.ini');
  with IniDat do begin
    writestring('Dream','Ordner',form2.Edit1.Text);
  end;
  iniDat.free;
// Programmdaten aus INI-Datei laden Ende
end;


procedure TForm1.UploadEEProm1Click(Sender: TObject);
VAR  f :File of Byte;
     r,wert :Byte;
     Anzahl: Byte;
     Adresse, m, n, i : Word;
     MaxAdr: Word;
     Code: Byte;
begin
   OpenDialog1.FileName := '*.bin';
   OpenDiaLog1.Execute;
   if OpenDialog1.FileName > '' then begin
     AssignFile(f,OpenDialog1.Filename);
    {$I-} Reset(f); {$I+}
    r:=IOResult;
    IF r = 0 then begin
      Adresse :=0;
      while (not Eof (f)) and (Adresse < 256) do begin
        Read(f,Code);
        Codearray[Adresse] := Code;
        Adresse := Adresse + 1;
      end;
      CloseFile(f);
  IICadr:= 208;
  for n:= 0 to 15 do begin
  Buf_adr :=0;
  I2C_Init;
  Start;
  Ausgeben (IICadr); {Adr 210, RAM, Ack?}
  Ausgeben (n*16);
     for m:= 0 to 15 do begin
       Ausgeben (CodeArray[n*16+m]);
     end;
     Stop;
  Open_USB_Device;
  Set_USB_Device_BitMode(255,1);
  FT_Current_Baud:=38400;
  Set_USB_Device_BaudRate;
  Write_USB_Device_Buffer( Buf_adr);
  Close_USB_Device;

     ProgressBar1.Position := n*16+15;
     Sleep (200);
     ProgressBar1.Position := 0;
   end;
  end;
 end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  statusbar1.Panels.Items[1].Text:= timetostr(now);
  statusbar1.Panels.Items[2].Text:= datetostr(now);
end;

procedure TForm1.UploadRAM1Click(Sender: TObject);
VAR  f :File of Byte;
     r,wert :Byte;
     Anzahl: Byte;
     Adresse, m, n, i : Word;
     MaxAdr: Word;
     Code: Byte;
begin
   OpenDialog1.FileName := '*.bin';
   OpenDiaLog1.Execute;
   if OpenDialog1.FileName > '' then begin
     AssignFile(f,OpenDialog1.Filename);
    {$I-} Reset(f); {$I+}
    r:=IOResult;
    IF r = 0 then begin
      Adresse :=0;
      while (not Eof (f)) and (Adresse < 256) do begin
        Read(f,Code);
        Codearray[Adresse] := Code;
        Adresse := Adresse + 1;
      end;
      CloseFile(f);
  IICadr:= 210;
  for n:= 0 to 15 do begin
  Buf_adr :=0;
  I2C_Init;
  Start;
  Ausgeben (IICadr); {Adr 210, RAM, Ack?}
  Ausgeben (n*16);
     for m:= 0 to 15 do begin
       Ausgeben (CodeArray[n*16+m]);
     end;
   Stop;
   Open_USB_Device;
  Set_USB_Device_BitMode(255,1);
  FT_Current_Baud:=38400;
  Set_USB_Device_BaudRate;
  Write_USB_Device_Buffer( Buf_adr);
  Close_USB_Device;


     ProgressBar1.Position := n*16+15;
     Sleep (200);
     ProgressBar1.Position := 0;
   end;
  end;
 end;
end;

procedure TForm1.L_sp1Click(Sender: TObject);
begin
  shellexecute(handle,nil,PChar('NAVTEX.pdf'),PChar(''),PChar(ExtractFilePath(Paramstr(0))),sw_shownormal);
end;

procedure TForm1.L_sp2Click(Sender: TObject);
begin
  shellexecute(handle,nil,PChar('sendeplan_fax.pdf'),PChar(''),PChar(ExtractFilePath(Paramstr(0))),sw_shownormal);
end;

procedure TForm1.L_sp3Click(Sender: TObject);
begin
  shellexecute(handle,nil,PChar('sendeplan_rtty1.pdf'),PChar(''),PChar(ExtractFilePath(Paramstr(0))),sw_shownormal);
end;

procedure TForm1.L_sp4Click(Sender: TObject);
begin
  shellexecute(handle,nil,PChar('sendeplan_rtty2.pdf'),PChar(''),PChar(ExtractFilePath(Paramstr(0))),sw_shownormal);
end;

procedure TForm1.L_sp1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  L_sp1.Font.Color:= clblue;
end;

procedure TForm1.L_sp2MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  L_sp2.Font.Color:= clblue;
end;

procedure TForm1.L_sp3MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  L_sp3.Font.Color:= clblue;
end;

procedure TForm1.L_sp4MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  L_sp4.Font.Color:= clblue;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  L_sp1.Font.Color:= clNavy;
  L_sp2.Font.Color:= clNavy;
  L_sp3.Font.Color:= clNavy;
  L_sp4.Font.Color:= clNavy;
end;

end.
